# MvnLiveLinkPlugin
MvnLiveLinkPlugin for Unreal


### Setup
First thing first, you need a running Unreal with some IDE and development setup.
Follow the documentation to get it working:
https://docs.unrealengine.com/en-us/GettingStarted/Installation

This code was built using Unreal 4.19 and it is the minimum Unreal version you have to install, due to the API used for Live Link. In case you have a newer version of Unreal, you either need to install the 4.19 version or you need to update the project to a new version. This update can be automatic, but might requires manual work to fix API dependencies - in case it's changed by Epic.

### Open the project
Once you have a working Unreal version you can open the project with clicking on the project file "MvnLiveLink.uproject". This should start Unreal with this project.

You can also add source code of this project to your existing Unreal project or start it via the Project browser: https://docs.unrealengine.com/en-us/Engine/Basics/Projects/Browser

This project has been divided by 3 main subfolders, due to the requirements from Unreal plugin system:
- Plugin code 					All code required to read network, parse data and animate	(MvnLiveLinkPlugin/Plugins/LiveLinkMvnPlugin/Source/LiveLinkMvnPlugin
- Editor code for the plugin 	All codes for editor extension, so the plugin can have UI 	(MvnLiveLinkPlugin/Plugins/LiveLinkMvnPlugin/Source/LiveLinkMvnPluginEditor)
- Test Project 					Test code to animate an MvnPuppet 							(MvnLiveLinkPlugin)

### Creating an extension
Using the plugin does not necessary requires the complete development environment, neither the source code. The idea of the plugin is to be able to upload it to marketplace and/or send it to a customer as a extension plugin.

Before you can send out in such a format, you need to create it. Follow the instruction from Epic: https://wiki.unrealengine.com/An_Introduction_to_UE4_Plugins

### Using the plugin
First you need to add the plugin into your project. You can either use the source code directly as it is mentioned above or you can install the extension plugin into a new  or existing Unreal project. 
There are several ways of adding a plugin, you can follow the Plugin's documentation from above or you can directly copy it into your plugin folder: https://answers.unrealengine.com/questions/323539/how-to-add-plugins.html

Once you have the plugin added into your Project, you need to build the project first. Since it is a plugin, you need to restart Unreal after this. (only at first time use)

Now, that everything is setup, you can use the plugin to connect to Xsens's MVN network stream. You have to setup a few things to make sure it will work:

Browse for the installed Plugins via the "Edit->Plugins" menu and check it's status.
- Make sure the Live Link plugin (engine plugin from Unreal) is enabled
- Make sure the MvnLiveLink plugin (Xsens's plugin) is enabled

Start the plugin via the Built-in Live Link window.
- Open the Live Link Window via the "Window" menu
- Click on "Add"
- Select Xsens Live Source
- Set the port number
- Click on OK to start the plugin
At this point the plugin is listening to incoming data from network. You should enable the streaming in MVN.
The plugin contains a test project which has an MvnPuppet in a test level and connected to the stream. Once the MVN stream is available for Unreal, you should see this puppet moving.

### Setup MVN to stream data
In MVN you have to enable the streaming of your data.
- make sure networking is enabled
- make sure the port and ip address is correct (same as you set in Unreal)
- use default quaternion data stream
- Start Playing the animation




