// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "Components/ActorComponent.h"
#include "Runtime/Engine/Classes/Components/PoseableMeshComponent.h"
#include "CharacterTPoseGenerator.generated.h"


UCLASS( ClassGroup=(Custom), meta=(BlueprintSpawnableComponent) )
class UCharacterTPoseGenerator : public UActorComponent
{
	GENERATED_BODY()

public:	
	// Sets default values for this component's properties
	UCharacterTPoseGenerator();

protected:
	// Called when the game starts
	virtual void BeginPlay() override;

public:	
	// Called every frame
	virtual void TickComponent(float DeltaTime, ELevelTick TickType, FActorComponentTickFunction* ThisTickFunction) override;

private:
	// start transform keeps the starting position of the Actor
	FTransform StartTransform;
	
	// Reference to Owner actor of this component
	AActor* Actor;
	
	// Reference to Poesable mesh which contains access to bones
	UPoseableMeshComponent* PoseableMesh;
	
	// Print TPose struct to log
	void PrintTPose(EBoneSpaces::Type space);
	
	//
	//	FQuat referenceSkeleton[SegData::XS_SEG_NUM];
	//	std::map<SegData::SegmentIndexes, FName> bones;
	
	//	void SetDefaults();
	
};
