// Fill out your copyright notice in the Description page of Project Settings.

#include "LiveLinkTest.h"

// quick debug print to ui
#define printUI(id, text) if (GEngine) GEngine->AddOnScreenDebugMessage(id, 4, FColor::White,text)

// Sets default values
ALiveLinkTest::ALiveLinkTest()
{
 	// Set this actor to call Tick() every frame.  You can turn this off to improve performance if you don't need it.
	PrimaryActorTick.bCanEverTick = true;
	
	Actor = GetOwner();

}

// Called when the game starts or when spawned
void ALiveLinkTest::BeginPlay()
{
	Super::BeginPlay();
	
	PrintTPose(EBoneSpaces::ComponentSpace);
	
}

// Called every frame
void ALiveLinkTest::Tick(float DeltaTime)
{
	Super::Tick(DeltaTime);

}

// Initialize the model
void ALiveLinkTest::PrintTPose(EBoneSpaces::Type space)
{
	try
	{
		//find reference
		if(Actor != NULL)
		{
			StartTransform = Actor->GetActorTransform();
			
			PoseableMesh = Actor->FindComponentByClass<UPoseableMeshComponent>();
			if(PoseableMesh != NULL)
			{
				
				//print to log
				int32 NumBones = PoseableMesh->GetNumBones();
				
				UE_LOG(LogTemp, Log, TEXT("const TArray<FTransform> SegData::TPose = { //Actor:%s"), *Actor->GetHumanReadableName());
				
				for (int32 i = 0; i < NumBones; ++i)
				{
//					EBoneSpaces space = EBoneSpaces::WorldSpace;
					FName boneName = PoseableMesh->GetBoneName(i);
					//	FTransform(FQuat().MakeFromEuler(FVector( 0.000014f, -0.000010f, 89.999985f)), FVector(216.722870f,-19.999935f,139.896027f), FVector(1.000000f, 1.000000f, 1.000000f)),		//Hips
					FTransform tr = PoseableMesh->GetBoneTransformByName(boneName, space);
					FVector pos = tr.GetLocation();
					FVector scale = tr.GetScale3D();
					FQuat rot = tr.GetRotation();
					FVector euler = rot.Euler();
					
					UE_LOG(LogTemp, Warning, TEXT("FTransform(FQuat().MakeFromEuler(FVector(%f,%f,%f)), FVector(%f,%f,%f), FVector(%f,%f,%f)),  //%s")
						   , euler.X, euler.Y, euler.Z
						   , pos.X, pos.Y, pos.Z
						   , scale.X, scale.Y, scale.Z
						   , *PoseableMesh->GetBoneName(i).ToString());
				}
				
				UE_LOG(LogTemp, Log, TEXT("//"));
				UE_LOG(LogTemp, Log, TEXT("FTransform(FQuat::Identity, FVector::ZeroVector, FVector::OneVector),	//prop - reserved"));
				UE_LOG(LogTemp, Log, TEXT("FTransform(FQuat::Identity, FVector::ZeroVector, FVector::OneVector),	//prop - reserved"));
				UE_LOG(LogTemp, Log, TEXT("FTransform(FQuat::Identity, FVector::ZeroVector, FVector::OneVector),	//prop - reserved"));
				UE_LOG(LogTemp, Log, TEXT("FTransform(FQuat::Identity, FVector::ZeroVector, FVector::OneVector),	//prop - reserved"));
				UE_LOG(LogTemp, Log, TEXT("}; //Actor:%s"), *Actor->GetHumanReadableName());
			}
			else
			{
				printUI(-1, TEXT("InitPose failed: Missing posemesh!"));
			}
			
		}
	}
	catch(...)
	{
		printUI(-1, TEXT("ERROR while initing Model"));
	}
	
}


