// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "Components/ActorComponent.h"
#include "Runtime/Engine/Classes/Components/PoseableMeshComponent.h"
#include "LiveLinkTest.generated.h"

UCLASS()
class ALiveLinkTest : public AActor
{
	GENERATED_BODY()
	
public:	
	// Sets default values for this actor's properties
	ALiveLinkTest();
	virtual void Tick(float DeltaTime) override;
	

protected:
	// Called when the game starts or when spawned
	virtual void BeginPlay() override;
	
	
private:
	// start transform keeps the starting position of the Actor
	FTransform StartTransform;
	
	// Reference to Owner actor of this component
	AActor* Actor;
	
	// Reference to Poesable mesh which contains access to bones
	UPoseableMeshComponent* PoseableMesh;
	void PrintTPose(EBoneSpaces::Type space);
};
